Pair
Date: 2017-02-08

org.apache.commons.lang3.tuple

## Class Pair<L,R>

- java.lang.Object
- - org.apache.commons.lang3.tuple.Pair<L,R>

- Type Parameters:
    `L` - the left element type
    `R` - the right element type
  All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<Pair<L,R>>, java.util.Map.Entry<L,R>
  Direct Known Subclasses:
    Diff, ImmutablePair, MutablePair

      public abstract class Pair<L,R>
      extends java.lang.Object
      implements java.util.Map.Entry<L,R>, java.lang.Comparable<Pair<L,R>>, java.io.Serializable

  A pair consisting of two elements.

  This class is an abstract implementation defining the basic API. It refers to the elements as 'left' and 'right'. It also implements the `Map.Entry` interface where the key is 'left' and the value is 'right'.

  Subclass implementations may be mutable or immutable. However, there is no restriction on the type of the stored objects that may be stored. If mutable objects are stored in the pair, then the pair itself effectively becomes mutable.

  Since:
    Lang 3.0
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Pair()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(Pair<L,R> other)` Compares the pair based on the left element followed by the right element.
    `boolean` | `equals(java.lang.Object obj)` Compares this pair to another based on the two elements.
    `L` | `getKey()` Gets the key from this pair.
    `abstract L` | `getLeft()` Gets the left element from this pair.
    `abstract R` | `getRight()` Gets the right element from this pair.
    `R` | `getValue()` Gets the value from this pair.
    `int` | `hashCode()` Returns a suitable hash code.
    `static <L,R> Pair<L,R>` | `of(L left, R right)` Obtains an immutable pair of from two objects inferring the generic types.
    `java.lang.String` | `toString()` Returns a String representation of this pair using the format `($left,$right)`.
    `java.lang.String` | `toString(java.lang.String format)` Formats the receiver using the given format.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map.Entry

      `setValue`

- - ### Constructor Detail

    - #### Pair

          public Pair()

  - ### Method Detail

    - #### of

          public static <L,R> Pair<L,R> of(L left,
                           R right)

      Obtains an immutable pair of from two objects inferring the generic types.

      This factory allows the pair to be created using inference to obtain the generic types.

      Type Parameters:
        `L` - the left element type
        `R` - the right element type
      Parameters:
        `left` - the left element, may be null
        `right` - the right element, may be null
      Returns:
        a pair formed from the two parameters, not null

    - #### getLeft

          public abstract L getLeft()

      Gets the left element from this pair.

      When treated as a key-value pair, this is the key.

      Returns:
        the left element, may be null

    - #### getRight

          public abstract R getRight()

      Gets the right element from this pair.

      When treated as a key-value pair, this is the value.

      Returns:
        the right element, may be null

    - #### getKey

          public final L getKey()

      Gets the key from this pair.

      This method implements the `Map.Entry` interface returning the left element as the key.

      Specified by:
        `getKey` in interface `java.util.Map.Entry<L,R>`
      Returns:
        the left element as the key, may be null

    - #### getValue

          public R getValue()

      Gets the value from this pair.

      This method implements the `Map.Entry` interface returning the right element as the value.

      Specified by:
        `getValue` in interface `java.util.Map.Entry<L,R>`
      Returns:
        the right element as the value, may be null

    - #### compareTo

          public int compareTo(Pair<L,R> other)

      Compares the pair based on the left element followed by the right element. The types must be `Comparable`.

      Specified by:
        `compareTo` in interface `java.lang.Comparable<Pair<L,R>>`
      Parameters:
        `other` - the other pair, not null
      Returns:
        negative if this is less, zero if equal, positive if greater

    - #### equals

          public boolean equals(java.lang.Object obj)

      Compares this pair to another based on the two elements.

      Specified by:
        `equals` in interface `java.util.Map.Entry<L,R>`
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `obj` - the object to compare to, null returns false
      Returns:
        true if the elements of the pair are equal

    - #### hashCode

          public int hashCode()

      Returns a suitable hash code. The hash code follows the definition in `Map.Entry`.

      Specified by:
        `hashCode` in interface `java.util.Map.Entry<L,R>`
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        the hash code

    - #### toString

          public java.lang.String toString()

      Returns a String representation of this pair using the format `($left,$right)`.

      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string describing this object, not null

    - #### toString

          public java.lang.String toString(java.lang.String format)

      Formats the receiver using the given format.

      This uses `Formattable` to perform the formatting. Two variables may be used to embed the left and right elements. Use `%1$s` for the left element (key) and `%2$s` for the right element (value). The default format used by `toString()` is `(%1$s,%2$s)`.

      Parameters:
        `format` - the format string, optionally containing `%1$s` and `%2$s`, not null
      Returns:
        the formatted string, not null